;=== Get LCID Function
;written by hobbyscripter <hobbyscripter at gmail dot com>
;licensed under "NSIS License"

;note: this function uses the same method that how
;      "NSIS exehead" get $LANGUAGE automatically
;      but without selecting the locale

;usage: ${GetLCID} [OutputValueVariable]

!macro GetLCID outputValue
	Call GetLCID
	Pop ${outputValue}
!macroend
!define GetLCID "!insertmacro GetLCID"

Function GetLCID
	; ----- Preserve Temp Variables -----
	Push $0

	; ----- Main Process -----
	; Check if System API 'GetUserDefaultUILanguage' exists or not
	System::Call "kernel32::GetModuleHandle(t 'KERNEL32.dll'.) i .s"
	System::Call "kernel32::GetProcAddress(i s., t 'GetUserDefaultUILanguage'.) i .r0"
	IntCmp $0 0 No_GetUserDefaultUILanguage No_GetUserDefaultUILanguage 0
	;Has_GetUserDefaultUILanguage:
		System::Call "kernel32::GetUserDefaultLangID()i.r0" ; Get Locale ID
		Exch $0 ; STACK: [...] << OutputValue ; $0 = $0
		Return

	No_GetUserDefaultUILanguage:
		ReadRegStr $0 HKCU "Control Panel\Desktop\ResourceLocale" ""
		StrCmp $0 "" No_ResourceLocale_RegEntry 0
		;Has_ResourceLocale_RegEntry:
			IntFmt $0 "%d" "0x$0" ; Reformat from HEX to DEC
			Exch $0 ; STACK: [...] << OutputValue ; $0 = $0
			Return

		No_ResourceLocale_RegEntry:
			ClearErrors ; Clear the errors caused by previous ReadRegStr command
			ReadRegStr $0 HKU ".DEFAULT\Control Panel\International" "Locale"
			IntFmt $0 "%d" "0x$0" ; Reformat from HEX to DEC
			Exch $0 ; STACK: [...] << OutputValue ; $0 = $0
			Return

FunctionEnd
