; =====
; Get Unique Executable Name
;   version 0.0.0.1
;   written by hobbyscripter <hobbyscripter@gmail.com>
; =====

; =====
; Usage
; =====
; [code]
; ${GetNotRunningExecutableName} OutputVar OriginalExeDir OriginalExeName
; [/code]
; =====

; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!ifndef GetUniqueExeNameHeader
!define GetUniqueExeNameHeader

; =====
; Macro
; =====
!macro GetUniqueExeNameCallMacro OutputVar OriginalExeDir OriginalExeName
  Push ${OriginalExeDir}
  Push ${OriginalExeName}
  Call GetUniqueExeNameFunc
  Pop ${OutputVar}
!macroend
!define GetUniqueExeName "!insertmacro GetUniqueExeNameCallMacro"

; =====
; Function Declaration
; =====
Function GetUniqueExeNameFunc
  ; -----
  ; Function Init
  ; -----
  ; [STACK] << [OrginalExeDir] << [OrginalExeName]
  Exch $R1 ; [STACK] << [OrginalExeDir] << $R1 ; $R1 = OrginalExeName
  Exch ; [STACK] << $R1 << [OrginalExeDir]
  Exch $R2 ; [STACK] << $R1 << $R2 ; $R2 = OrginalExeDir
  Push $R3 ; [STACK] << $R1 << $R2 << $R3
  Push $R4 ; [STACK] << $R1 << $R2 << $R3 << $R4
  Push $R0 ; [STACK] << $R1 << $R2 << $R3 << $R4 << $R0
  !define InputExeName $R1
  !define InputExeDir $R2
  !define OutputExeName $R3
  !define FileCount $R4
  !define FindProcReturn $R0 ; For unknown reason, it seems that FindProc would only put the data to $R0

  ; -----
  ; Main
  ; -----
  StrCpy ${OutputExeName} ${InputExeName} -4 ; Get Orginal Name, eg. firefox.exe => firefox

  IntOp ${FileCount} 0 + 0
  FindUniqueNameLoop:
    IntOp ${FileCount} ${FileCount} + 1
    IfFileExists "${InputExeDir}\${OutputExeName}${FileCount}.exe" FindUniqueNameLoop
    FindProcDLL::FindProc "${OutputExeName}${FileCount}.exe"
    StrCmp ${FindProcReturn} "1" FindUniqueNameLoop 0

  StrCpy ${OutputExeName} "${OutputExeName}${FileCount}.exe"

  ; -----
  ; Variable Restore
  ; -----
  !undef InputExeName
  !undef InputExeDir
  !undef OutputExeName
  !undef FileCount
  !undef FindProcReturn
  StrCpy $R1 $R3
  ; [STACK] << $R1 << $R2 << $R3 << $R4 << $R0
  Pop $R0 ; [STACK] << $R1 << $R2 << $R3 << $R4
  Pop $R4 ; [STACK] << $R1 << $R2 << $R3
  Pop $R3 ; [STACK] << $R1 << $R2
  Pop $R2 ; [STACK] << $R1
  Exch $R1 ; [STACK] << [Output]
FunctionEnd

!endif